<?php
/*

TEMPLATE class
evg_n@mail.ru
http://uggway.ru

*/

class TEMPL{

	var $fname;//template file
	var $name;//name of template
	var $AA;//associative array
	var $AAA;//array of associativa array
	var $T;
	var $O;
	var $Prepared;
	var $BC;
	var $EC;
	
	// constructor
	// $fname - template file name
	function TEMPL($fname)
	{
		$this->fname=$fname;
		$this->BC="<$";
		$this->EC="$>";
		$this->AA=array();
		$this->AAA=array();
		
		$this->Load();
		$this->Prepared=FALSE;
	}
	
	// load template if exists
	function Load()
	{
		if(file_exists($this->fname)){	
			$this->T=file($this->fname);
		}	
	}

	function SetValue($vals)//array of values
	{
		$this->AA=array();
		foreach($vals as $vk=>$vv){
			$this->AA[$this->BC.$vk.$this->EC]=$vv;
		}		
		$this->Prepared=FALSE;
		
	}
	
	function SetValueA($vala)
	{
		$this->AA=array();
		$this->AAA=$vala;		
	}

	function AddVal($var,$val)
	{	
		$this->AA[$this->BC.$var.$this->EC]=$val;
	}
	
	function AddValA($val)
	{
		$this->AAA[]=$val;
	}
	
	function Prepare()
	{	
		if($this->T){		
			$v=join("",$this->T);					
			if(count($this->AA)>0)
				$this->O=strtr($v,$this->AA);				
			else $this->O=$v;
			
			$this->Prepared=TRUE;
		}
	}
	
	function PrepareA()
	{	
		if($this->T){		
			$v=join("",$this->T);					
			$ret="";
			if(count($this->AAA)>0){
				foreach($this->AAA as $i){
					$this->SetValue($i);
					if(count($this->AA)>0)
						$ret.=strtr($v,$this->AA);				
					else $ret.=$v;
				}
			}
			else 
				$ret=$v;
			$this->O=$ret;
			$this->Prepared=TRUE;
		}
	}
	
	function Out()
	{
		
		if($this->Prepared==FALSE)
		{
			if(count($this->AAA)>0)$this->PrepareA();					
			else 
			$this->Prepare();
		}
			
		if($this->Prepared==FALSE) return "";	
		ob_start();
        eval("?>".$this->O."<?");
        $out = ob_get_contents();
        ob_end_clean();		
		return $out;
	}
	
	/*public function block($block, array $data = NULL)
    {
        if (file_exists($block))
        {
            if ($data !== NULL) extract($data);
            ob_start();
            require $block;
            $out = ob_get_contents();
            ob_end_clean();
            return $out;
        }
        else
        {
            return 'File ' . $block . ' not exists.';
        }
    }*/
	 
/*

1.<?PHP 
2.class View {
3.    
4.    protected $_template;
5.    protected $_data = array();
6.    
7.    public function __construct($template)
8.    {
9.        if (file_exists($template))
10.        {
11.            $this->_template = $template;
12.        }
13.        else
14.        {
15.            exit('File ' . $template . ' not exists.');
16.        }
17.    }
18.    
19.    public function __set($key, $value)
20.    {
21.        $this->_data[$key] = $value;
22.    }
23.    
24.    1.    public function block($template_block, array $data = NULL)
2.    {
3.        if (file_exists($template_block))
4.        {
5.            if ($data !== NULL) extract($data, EXTR_SKIP);
6.            ob_start();
7.            require $template_block;
8.            $out = ob_get_contents();
9.            ob_end_clean();
10.            return $out;
11.        }
12.        else
13.        {
14.            return 'File ' . $template_block . ' not exists.';
15.        }
16.    }
40.    
41.    public function display()
42.    {
43.        extract($this->_data);
44.        require ($this->_template);
45.    }
46.    
47.}
48.?>

1.<?PHP 
2.header('Content-Type: text/html; charset=utf-8');
3.//      
4.require_once ('inc/view.class.php');
5.$view = new View('views/template.php');
6.//     
7.$view->title = ' ';
8.$view->hello = ' !';
9.//      
10.$data_menu = array(
11.    'block_name' => ' ',
12.    'links' => array(
13.        'index.php' => '',
14.        'news.php' => '',
15.        'about.php' => '',
16.    )
17.);
18.//       menu.php    $data_menu
19.$view->block_menu = $view->block('views/menu.php', $data_menu);
20.//    
21.$view->display();
22.?>

1.<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
2.<html xmlns="http://www.w3.org/1999/xhtml">
3.<head>
4.<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
5.<title><?=$title?></title>
6.</head>
7.<body>
8.<h1><?=$hello?></h1>
9.<?=$block_menu?>
10.</body>
11.</html>

1.<div id="menu">
2.    <p><?=$block_name?></p>
3.    <ul>
4.    <?PHP foreach($links  as $key => $value): ?>
5.        <li><a href="<?=$key?>"><?=$value?></a></li>
6.    <?PHP endforeach ?>
7.    </ul>
8.</div>

*/
}
?>